﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

using EA;

namespace EAUtil
{
    public static class EaUtil
    {
        /// <summary>
        /// Recursive.
        /// </summary>
        /// <param name="diagramList"></param>
        /// <param name="package"></param>
        public static void GetAllDiagramsInPackage(List<Diagram> diagramList, Package package)
        {
            Debug.Print("Package: {0}", package.Name);
            foreach (Diagram diagram in package.Diagrams)
            {
                diagramList.Add(diagram);
            }
            foreach (Package subPackage in package.Packages)
            {
                GetAllDiagramsInPackage(diagramList, subPackage);
            }
        }
    }
}
