﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Tuesday, 28 April 2009 3:09:33 PM
// Code is generated using templates: SD.TemplateBindings.SharedTemplates.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System;
using System.Collections;
using System.Collections.Generic;
using WorkflowService.Model;
using WorkflowService.Model.FactoryClasses;
using WorkflowService.Model.HelperClasses;
using SD.LLBLGen.Pro.ORMSupportClasses;

namespace WorkflowService.Model.RelationClasses
{
	/// <summary>Implements the static Relations variant for the entity: WorkflowInstance. </summary>
	public partial class WorkflowInstanceRelations : StateMachineInstanceRelations
	{
		/// <summary>CTor</summary>
		public WorkflowInstanceRelations()
		{
		}

		/// <summary>Gets all relations of the WorkflowInstanceEntity as a list of IEntityRelation objects.</summary>
		/// <returns>a list of IEntityRelation objects</returns>
		public override List<IEntityRelation> GetAllRelations()
		{
			List<IEntityRelation> toReturn = base.GetAllRelations();



			return toReturn;
		}

		#region Class Property Declarations



		/// <summary>Returns a new IEntityRelation object, between WorkflowInstanceEntity and StateEntity over the m:1 relation they have, using the relation between the fields:
		/// WorkflowInstance.CurrentState - State.Id
		/// </summary>
		public override IEntityRelation StateEntityUsingCurrentState
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToOne, "State", false);
				relation.AddEntityFieldPair(StateFields.Id, WorkflowInstanceFields.CurrentState);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateEntity", false);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("WorkflowInstanceEntity", true);
				return relation;
			}
		}
		/// <summary>Returns a new IEntityRelation object, between WorkflowInstanceEntity and StateMachineEntity over the m:1 relation they have, using the relation between the fields:
		/// WorkflowInstance.StateMachineId - StateMachine.Id
		/// </summary>
		public override IEntityRelation StateMachineEntityUsingStateMachineId
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToOne, "StateMachine", false);
				relation.AddEntityFieldPair(StateMachineFields.Id, WorkflowInstanceFields.StateMachineId);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateMachineEntity", false);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("WorkflowInstanceEntity", true);
				return relation;
			}
		}

		/// <summary>Returns a new IEntityRelation object, between WorkflowInstanceEntity and StateMachineInstanceEntity over the 1:1 relation they have, which is used to build a target per entity hierarchy, and is using the relation between the fields:
		/// WorkflowInstance.Id - StateMachineInstance.Id
		/// </summary>
		internal IEntityRelation RelationToSuperTypeStateMachineInstanceEntity
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToOne, false);

	
	
				relation.AddEntityFieldPair(StateMachineInstanceFields.Id, WorkflowInstanceFields.Id);
	
				relation.IsHierarchyRelation=true;
				return relation;
			}
		}
		/// <summary>Returns the relation object the entity, to which this relation factory belongs, has with the subtype with the specified name</summary>
		/// <param name="subTypeEntityName">name of direct subtype which is a subtype of the current entity through the relation to return.</param>
		/// <returns>relation which makes the current entity a supertype of the subtype entity with the name specified, or null if not applicable/found</returns>
		public override IEntityRelation GetSubTypeRelation(string subTypeEntityName)
		{
			return null;
		}
		
		
		/// <summary>Returns the relation object the entity, to which this relation factory belongs, has with its supertype, if applicable.</summary>
		/// <returns>relation which makes the current entity a subtype of its supertype entity or null if not applicable/found</returns>
		public override IEntityRelation GetSuperTypeRelation()
		{
			return this.RelationToSuperTypeStateMachineInstanceEntity;
		}

		#endregion

		#region Included Code

		#endregion
	}
}
