﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Tuesday, 28 April 2009 3:09:33 PM
// Code is generated using templates: SD.TemplateBindings.SharedTemplates.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System;
using System.ComponentModel;
using System.Collections.Generic;
#if !CF
using System.Runtime.Serialization;
#endif
using System.Xml.Serialization;
using WorkflowService.Model;
using WorkflowService.Model.HelperClasses;
using WorkflowService.Model.FactoryClasses;
using WorkflowService.Model.RelationClasses;

using SD.LLBLGen.Pro.ORMSupportClasses;

namespace WorkflowService.Model.EntityClasses
{
	
	// __LLBLGENPRO_USER_CODE_REGION_START AdditionalNamespaces
	// __LLBLGENPRO_USER_CODE_REGION_END

	/// <summary>
	/// Entity class which represents the entity 'State'.<br/><br/>
	/// 
	/// </summary>
	[Serializable]
	public partial class StateEntity : CommonEntityBase, ISerializable
		// __LLBLGENPRO_USER_CODE_REGION_START AdditionalInterfaces
		// __LLBLGENPRO_USER_CODE_REGION_END	
	{
		#region Class Member Declarations
		private EntityCollection<CanTransitionToEntity> _canTransitionTo_;
		private EntityCollection<CanTransitionToEntity> _canTransitionTo;
		private EntityCollection<StateMachineInstanceEntity> _stateMachineInstance;
		private EntityCollection<StateMachineEntity> _stateMachineCollectionViaStateMachineInstance;
		private StateMachineEntity _stateMachine;

		
		// __LLBLGENPRO_USER_CODE_REGION_START PrivateMembers
		// __LLBLGENPRO_USER_CODE_REGION_END
		#endregion

		#region Statics
		private static Dictionary<string, string>	_customProperties;
		private static Dictionary<string, Dictionary<string, string>>	_fieldsCustomProperties;

		/// <summary>All names of fields mapped onto a relation. Usable for in-memory filtering</summary>
		public static class MemberNames
		{
			/// <summary>Member name StateMachine</summary>
			public static readonly string StateMachine = "StateMachine";
			/// <summary>Member name CanTransitionTo_</summary>
			public static readonly string CanTransitionTo_ = "CanTransitionTo_";
			/// <summary>Member name CanTransitionTo</summary>
			public static readonly string CanTransitionTo = "CanTransitionTo";
			/// <summary>Member name StateMachineInstance</summary>
			public static readonly string StateMachineInstance = "StateMachineInstance";
			/// <summary>Member name StateMachineCollectionViaStateMachineInstance</summary>
			public static readonly string StateMachineCollectionViaStateMachineInstance = "StateMachineCollectionViaStateMachineInstance";

		}
		#endregion
		
		/// <summary> Static CTor for setting up custom property hashtables. Is executed before the first instance of this entity class or derived classes is constructed. </summary>
		static StateEntity()
		{
			SetupCustomPropertyHashtables();
		}

		/// <summary> CTor</summary>
		public StateEntity():base("StateEntity")
		{
			InitClassEmpty(null, CreateFields());
		}

		/// <summary> CTor</summary>
		/// <remarks>For framework usage.</remarks>
		/// <param name="fields">Fields object to set as the fields for this entity.</param>
		public StateEntity(IEntityFields2 fields):base("StateEntity")
		{
			InitClassEmpty(null, fields);
		}

		/// <summary> CTor</summary>
		/// <param name="validator">The custom validator object for this StateEntity</param>
		public StateEntity(IValidator validator):base("StateEntity")
		{
			InitClassEmpty(validator, CreateFields());
		}
				

		/// <summary> CTor</summary>
		/// <param name="id">PK value for State which data should be fetched into this State object</param>
		/// <remarks>The entity is not fetched by this constructor. Use a DataAccessAdapter for that.</remarks>
		public StateEntity(System.Int32 id):base("StateEntity")
		{
			InitClassEmpty(null, CreateFields());
			this.Id = id;
		}

		/// <summary> CTor</summary>
		/// <param name="id">PK value for State which data should be fetched into this State object</param>
		/// <param name="validator">The custom validator object for this StateEntity</param>
		/// <remarks>The entity is not fetched by this constructor. Use a DataAccessAdapter for that.</remarks>
		public StateEntity(System.Int32 id, IValidator validator):base("StateEntity")
		{
			InitClassEmpty(validator, CreateFields());
			this.Id = id;
		}

		/// <summary> Protected CTor for deserialization</summary>
		/// <param name="info"></param>
		/// <param name="context"></param>
		[EditorBrowsable(EditorBrowsableState.Never)]
		protected StateEntity(SerializationInfo info, StreamingContext context) : base(info, context)
		{
			if(SerializationHelper.Optimization != SerializationOptimization.Fast) 
			{
				_canTransitionTo_ = (EntityCollection<CanTransitionToEntity>)info.GetValue("_canTransitionTo_", typeof(EntityCollection<CanTransitionToEntity>));
				_canTransitionTo = (EntityCollection<CanTransitionToEntity>)info.GetValue("_canTransitionTo", typeof(EntityCollection<CanTransitionToEntity>));
				_stateMachineInstance = (EntityCollection<StateMachineInstanceEntity>)info.GetValue("_stateMachineInstance", typeof(EntityCollection<StateMachineInstanceEntity>));
				_stateMachineCollectionViaStateMachineInstance = (EntityCollection<StateMachineEntity>)info.GetValue("_stateMachineCollectionViaStateMachineInstance", typeof(EntityCollection<StateMachineEntity>));
				_stateMachine = (StateMachineEntity)info.GetValue("_stateMachine", typeof(StateMachineEntity));
				if(_stateMachine!=null)
				{
					_stateMachine.AfterSave+=new EventHandler(OnEntityAfterSave);
				}

				base.FixupDeserialization(FieldInfoProviderSingleton.GetInstance());
			}
			
			// __LLBLGENPRO_USER_CODE_REGION_START DeserializationConstructor
			// __LLBLGENPRO_USER_CODE_REGION_END
		}

		
		/// <summary>Performs the desync setup when an FK field has been changed. The entity referenced based on the FK field will be dereferenced and sync info will be removed.</summary>
		/// <param name="fieldIndex">The fieldindex.</param>
		protected override void PerformDesyncSetupFKFieldChange(int fieldIndex)
		{
			switch((StateFieldIndex)fieldIndex)
			{
				case StateFieldIndex.StateMachineId:
					DesetupSyncStateMachine(true, false);
					break;
				default:
					base.PerformDesyncSetupFKFieldChange(fieldIndex);
					break;
			}
		}
				
		/// <summary>Gets the inheritance info provider instance of the project this entity instance is located in. </summary>
		/// <returns>ready to use inheritance info provider instance.</returns>
		protected override IInheritanceInfoProvider GetInheritanceInfoProvider()
		{
			return InheritanceInfoProviderSingleton.GetInstance();
		}
		
		/// <summary> Sets the related entity property to the entity specified. If the property is a collection, it will add the entity specified to that collection.</summary>
		/// <param name="propertyName">Name of the property.</param>
		/// <param name="entity">Entity to set as an related entity</param>
		/// <remarks>Used by prefetch path logic.</remarks>
		[EditorBrowsable(EditorBrowsableState.Never)]
		public override void SetRelatedEntityProperty(string propertyName, IEntity2 entity)
		{
			switch(propertyName)
			{
				case "StateMachine":
					this.StateMachine = (StateMachineEntity)entity;
					break;
				case "CanTransitionTo_":
					this.CanTransitionTo_.Add((CanTransitionToEntity)entity);
					break;
				case "CanTransitionTo":
					this.CanTransitionTo.Add((CanTransitionToEntity)entity);
					break;
				case "StateMachineInstance":
					this.StateMachineInstance.Add((StateMachineInstanceEntity)entity);
					break;
				case "StateMachineCollectionViaStateMachineInstance":
					this.StateMachineCollectionViaStateMachineInstance.IsReadOnly = false;
					this.StateMachineCollectionViaStateMachineInstance.Add((StateMachineEntity)entity);
					this.StateMachineCollectionViaStateMachineInstance.IsReadOnly = true;
					break;

				default:
					break;
			}
		}
		
		/// <summary>Gets the relation objects which represent the relation the fieldName specified is mapped on. </summary>
		/// <param name="fieldName">Name of the field mapped onto the relation of which the relation objects have to be obtained.</param>
		/// <returns>RelationCollection with relation object(s) which represent the relation the field is maped on</returns>
		public override RelationCollection GetRelationsForFieldOfType(string fieldName)
		{
			return StateEntity.GetRelationsForField(fieldName);
		}

		/// <summary>Gets the relation objects which represent the relation the fieldName specified is mapped on. </summary>
		/// <param name="fieldName">Name of the field mapped onto the relation of which the relation objects have to be obtained.</param>
		/// <returns>RelationCollection with relation object(s) which represent the relation the field is maped on</returns>
		public static RelationCollection GetRelationsForField(string fieldName)
		{
			RelationCollection toReturn = new RelationCollection();
			switch(fieldName)
			{
				case "StateMachine":
					toReturn.Add(StateEntity.Relations.StateMachineEntityUsingStateMachineId);
					break;
				case "CanTransitionTo_":
					toReturn.Add(StateEntity.Relations.CanTransitionToEntityUsingToStateId);
					break;
				case "CanTransitionTo":
					toReturn.Add(StateEntity.Relations.CanTransitionToEntityUsingFromStateId);
					break;
				case "StateMachineInstance":
					toReturn.Add(StateEntity.Relations.StateMachineInstanceEntityUsingCurrentState);
					break;
				case "StateMachineCollectionViaStateMachineInstance":
					toReturn.Add(StateEntity.Relations.StateMachineInstanceEntityUsingCurrentState, "StateEntity__", "StateMachineInstance_", JoinHint.None);
					toReturn.Add(StateMachineInstanceEntity.Relations.StateMachineEntityUsingStateMachineId, "StateMachineInstance_", string.Empty, JoinHint.None);
					break;

				default:

					break;				
			}
			return toReturn;
		}
#if !CF
		/// <summary>Checks if the relation mapped by the property with the name specified is a one way / single sided relation. If the passed in name is null, it
		/// will return true if the entity has any single-sided relation</summary>
		/// <param name="propertyName">Name of the property which is mapped onto the relation to check, or null to check if the entity has any relation/ which is single sided</param>
		/// <returns>true if the relation is single sided / one way (so the opposite relation isn't present), false otherwise</returns>
		[EditorBrowsable(EditorBrowsableState.Never)]
		protected override bool CheckOneWayRelations(string propertyName)
		{
			// use template trick to calculate the # of single-sided / oneway relations
			int numberOfOneWayRelations = 0;
			switch(propertyName)
			{
				case null:
					return ((numberOfOneWayRelations > 0) || base.CheckOneWayRelations(null));


				default:
					return base.CheckOneWayRelations(propertyName);
			}
		}
#endif
		/// <summary> Sets the internal parameter related to the fieldname passed to the instance relatedEntity. </summary>
		/// <param name="relatedEntity">Instance to set as the related entity of type entityType</param>
		/// <param name="fieldName">Name of field mapped onto the relation which resolves in the instance relatedEntity</param>
		[EditorBrowsable(EditorBrowsableState.Never)]
		public override void SetRelatedEntity(IEntity2 relatedEntity, string fieldName)
		{
			switch(fieldName)
			{
				case "StateMachine":
					SetupSyncStateMachine(relatedEntity);
					break;
				case "CanTransitionTo_":
					this.CanTransitionTo_.Add((CanTransitionToEntity)relatedEntity);
					break;
				case "CanTransitionTo":
					this.CanTransitionTo.Add((CanTransitionToEntity)relatedEntity);
					break;
				case "StateMachineInstance":
					this.StateMachineInstance.Add((StateMachineInstanceEntity)relatedEntity);
					break;

				default:
					break;
			}
		}

		/// <summary> Unsets the internal parameter related to the fieldname passed to the instance relatedEntity. Reverses the actions taken by SetRelatedEntity() </summary>
		/// <param name="relatedEntity">Instance to unset as the related entity of type entityType</param>
		/// <param name="fieldName">Name of field mapped onto the relation which resolves in the instance relatedEntity</param>
		/// <param name="signalRelatedEntityManyToOne">if set to true it will notify the manytoone side, if applicable.</param>
		[EditorBrowsable(EditorBrowsableState.Never)]
		public override void UnsetRelatedEntity(IEntity2 relatedEntity, string fieldName, bool signalRelatedEntityManyToOne)
		{
			switch(fieldName)
			{
				case "StateMachine":
					DesetupSyncStateMachine(false, true);
					break;
				case "CanTransitionTo_":
					base.PerformRelatedEntityRemoval(this.CanTransitionTo_, relatedEntity, signalRelatedEntityManyToOne);
					break;
				case "CanTransitionTo":
					base.PerformRelatedEntityRemoval(this.CanTransitionTo, relatedEntity, signalRelatedEntityManyToOne);
					break;
				case "StateMachineInstance":
					base.PerformRelatedEntityRemoval(this.StateMachineInstance, relatedEntity, signalRelatedEntityManyToOne);
					break;

				default:
					break;
			}
		}

		/// <summary> Gets a collection of related entities referenced by this entity which depend on this entity (this entity is the PK side of their FK fields). These entities will have to be persisted after this entity during a recursive save.</summary>
		/// <returns>Collection with 0 or more IEntity2 objects, referenced by this entity</returns>
		public override List<IEntity2> GetDependingRelatedEntities()
		{
			List<IEntity2> toReturn = new List<IEntity2>();

			return toReturn;
		}
		
		/// <summary> Gets a collection of related entities referenced by this entity which this entity depends on (this entity is the FK side of their PK fields). These
		/// entities will have to be persisted before this entity during a recursive save.</summary>
		/// <returns>Collection with 0 or more IEntity2 objects, referenced by this entity</returns>
		public override List<IEntity2> GetDependentRelatedEntities()
		{
			List<IEntity2> toReturn = new List<IEntity2>();
			if(_stateMachine!=null)
			{
				toReturn.Add(_stateMachine);
			}

			return toReturn;
		}
		
		/// <summary>Gets a list of all entity collections stored as member variables in this entity. The contents of the ArrayList is used by the DataAccessAdapter to perform recursive saves. Only 1:n related collections are returned.</summary>
		/// <returns>Collection with 0 or more IEntityCollection2 objects, referenced by this entity</returns>
		public override List<IEntityCollection2> GetMemberEntityCollections()
		{
			List<IEntityCollection2> toReturn = new List<IEntityCollection2>();
			toReturn.Add(this.CanTransitionTo_);
			toReturn.Add(this.CanTransitionTo);
			toReturn.Add(this.StateMachineInstance);

			return toReturn;
		}
		


		/// <summary>ISerializable member. Does custom serialization so event handlers do not get serialized. Serializes members of this entity class and uses the base class' implementation to serialize the rest.</summary>
		/// <param name="info"></param>
		/// <param name="context"></param>
		[EditorBrowsable(EditorBrowsableState.Never)]
		public override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			if (SerializationHelper.Optimization != SerializationOptimization.Fast) 
			{
				info.AddValue("_canTransitionTo_", ((_canTransitionTo_!=null) && (_canTransitionTo_.Count>0) && !this.MarkedForDeletion)?_canTransitionTo_:null);
				info.AddValue("_canTransitionTo", ((_canTransitionTo!=null) && (_canTransitionTo.Count>0) && !this.MarkedForDeletion)?_canTransitionTo:null);
				info.AddValue("_stateMachineInstance", ((_stateMachineInstance!=null) && (_stateMachineInstance.Count>0) && !this.MarkedForDeletion)?_stateMachineInstance:null);
				info.AddValue("_stateMachineCollectionViaStateMachineInstance", ((_stateMachineCollectionViaStateMachineInstance!=null) && (_stateMachineCollectionViaStateMachineInstance.Count>0) && !this.MarkedForDeletion)?_stateMachineCollectionViaStateMachineInstance:null);
				info.AddValue("_stateMachine", (!this.MarkedForDeletion?_stateMachine:null));

			}
			
			// __LLBLGENPRO_USER_CODE_REGION_START GetObjectInfo
			// __LLBLGENPRO_USER_CODE_REGION_END
			base.GetObjectData(info, context);
		}

		/// <summary> Method which will construct a filter (predicate expression) for the unique constraint defined on the fields:
		/// Id .</summary>
		/// <returns>true if succeeded and the contents is read, false otherwise</returns>
		public IPredicateExpression ConstructFilterForUCId()
		{
			IPredicateExpression filter = new PredicateExpression();
			filter.Add(new FieldCompareValuePredicate(base.Fields[(int)StateFieldIndex.Id], null, ComparisonOperator.Equal)); 
			return filter;
		}

		/// <summary> Method which will construct a filter (predicate expression) for the unique constraint defined on the fields:
		/// Name .</summary>
		/// <returns>true if succeeded and the contents is read, false otherwise</returns>
		public IPredicateExpression ConstructFilterForUCName()
		{
			IPredicateExpression filter = new PredicateExpression();
			filter.Add(new FieldCompareValuePredicate(base.Fields[(int)StateFieldIndex.Name], null, ComparisonOperator.Equal)); 
			return filter;
		}

		/// <summary>Returns true if the original value for the field with the fieldIndex passed in, read from the persistent storage was NULL, false otherwise.
		/// Should not be used for testing if the current value is NULL, use <see cref="TestCurrentFieldValueForNull"/> for that.</summary>
		/// <param name="fieldIndex">Index of the field to test if that field was NULL in the persistent storage</param>
		/// <returns>true if the field with the passed in index was NULL in the persistent storage, false otherwise</returns>
		public bool TestOriginalFieldValueForNull(StateFieldIndex fieldIndex)
		{
			return base.Fields[(int)fieldIndex].IsNull;
		}
		
		/// <summary>Returns true if the current value for the field with the fieldIndex passed in represents null/not defined, false otherwise.
		/// Should not be used for testing if the original value (read from the db) is NULL</summary>
		/// <param name="fieldIndex">Index of the field to test if its currentvalue is null/undefined</param>
		/// <returns>true if the field's value isn't defined yet, false otherwise</returns>
		public bool TestCurrentFieldValueForNull(StateFieldIndex fieldIndex)
		{
			return base.CheckIfCurrentFieldValueIsNull((int)fieldIndex);
		}

				
		/// <summary>Gets a list of all the EntityRelation objects the type of this instance has.</summary>
		/// <returns>A list of all the EntityRelation objects the type of this instance has. Hierarchy relations are excluded.</returns>
		public override List<IEntityRelation> GetAllRelations()
		{
			return new StateRelations().GetAllRelations();
		}
		

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'CanTransitionTo' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoCanTransitionTo_()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(CanTransitionToFields.ToStateId, null, ComparisonOperator.Equal, this.Id));
			return bucket;
		}

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'CanTransitionTo' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoCanTransitionTo()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(CanTransitionToFields.FromStateId, null, ComparisonOperator.Equal, this.Id));
			return bucket;
		}

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'StateMachineInstance' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoStateMachineInstance()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(StateMachineInstanceFields.CurrentState, null, ComparisonOperator.Equal, this.Id));
			return bucket;
		}

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'StateMachine' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoStateMachineCollectionViaStateMachineInstance()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.Relations.AddRange(GetRelationsForFieldOfType("StateMachineCollectionViaStateMachineInstance"));
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(StateFields.Id, null, ComparisonOperator.Equal, this.Id, "StateEntity__"));
			return bucket;
		}

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entity of type 'StateMachine' to this entity. Use DataAccessAdapter.FetchNewEntity() to fetch this related entity.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoStateMachine()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(StateMachineFields.Id, null, ComparisonOperator.Equal, this.StateMachineId));
			return bucket;
		}

	
		
		/// <summary>Creates entity fields object for this entity. Used in constructor to setup this entity in a polymorphic scenario.</summary>
		protected virtual IEntityFields2 CreateFields()
		{
			return EntityFieldsFactory.CreateEntityFieldsObject(WorkflowService.Model.EntityType.StateEntity);
		}

		/// <summary>
		/// Creates the ITypeDefaultValue instance used to provide default values for value types which aren't of type nullable(of T)
		/// </summary>
		/// <returns></returns>
		protected override ITypeDefaultValue CreateTypeDefaultValueProvider()
		{
			return new TypeDefaultValue();
		}

		/// <summary>Creates a new instance of the factory related to this entity</summary>
		protected override IEntityFactory2 CreateEntityFactory()
		{
			return EntityFactoryCache2.GetEntityFactory(typeof(StateEntityFactory));
		}
#if !CF
		/// <summary>Adds the member collections to the collections queue (base first)</summary>
		/// <param name="collectionsQueue">The collections queue.</param>
		protected override void AddToMemberEntityCollectionsQueue(Queue<IEntityCollection2> collectionsQueue) 
		{
			base.AddToMemberEntityCollectionsQueue(collectionsQueue);
			collectionsQueue.Enqueue(this._canTransitionTo_);
			collectionsQueue.Enqueue(this._canTransitionTo);
			collectionsQueue.Enqueue(this._stateMachineInstance);
			collectionsQueue.Enqueue(this._stateMachineCollectionViaStateMachineInstance);
		}
		
		/// <summary>Gets the member collections queue from the queue (base first)</summary>
		/// <param name="collectionsQueue">The collections queue.</param>
		protected override void GetFromMemberEntityCollectionsQueue(Queue<IEntityCollection2> collectionsQueue)
		{
			base.GetFromMemberEntityCollectionsQueue(collectionsQueue);
			this._canTransitionTo_ = (EntityCollection<CanTransitionToEntity>) collectionsQueue.Dequeue();
			this._canTransitionTo = (EntityCollection<CanTransitionToEntity>) collectionsQueue.Dequeue();
			this._stateMachineInstance = (EntityCollection<StateMachineInstanceEntity>) collectionsQueue.Dequeue();
			this._stateMachineCollectionViaStateMachineInstance = (EntityCollection<StateMachineEntity>) collectionsQueue.Dequeue();
		}
		
		/// <summary>Determines whether the entity has populated member collections</summary>
		/// <returns>true if the entity has populated member collections.</returns>
		protected override bool HasPopulatedMemberEntityCollections()
		{
			if (this._canTransitionTo_ != null)
			{
				return true;
			}
			if (this._canTransitionTo != null)
			{
				return true;
			}
			if (this._stateMachineInstance != null)
			{
				return true;
			}
			if (this._stateMachineCollectionViaStateMachineInstance != null)
			{
				return true;
			}
			return base.HasPopulatedMemberEntityCollections();
		}
		
		/// <summary>Creates the member entity collections queue.</summary>
		/// <param name="collectionsQueue">The collections queue.</param>
		/// <param name="requiredQueue">The required queue.</param>
		protected override void CreateMemberEntityCollectionsQueue(Queue<IEntityCollection2> collectionsQueue, Queue<bool> requiredQueue) 
		{
			base.CreateMemberEntityCollectionsQueue(collectionsQueue, requiredQueue);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<CanTransitionToEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CanTransitionToEntityFactory))) : null);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<CanTransitionToEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CanTransitionToEntityFactory))) : null);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<StateMachineInstanceEntity>(EntityFactoryCache2.GetEntityFactory(typeof(StateMachineInstanceEntityFactory))) : null);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<StateMachineEntity>(EntityFactoryCache2.GetEntityFactory(typeof(StateMachineEntityFactory))) : null);
		}
#endif
		/// <summary>
		/// Gets all related data objects, stored by name. The name is the field name mapped onto the relation for that particular data element. 
		/// </summary>
		/// <returns>Dictionary with per name the related referenced data element, which can be an entity collection or an entity or null</returns>
		public override Dictionary<string, object> GetRelatedData()
		{
			Dictionary<string, object> toReturn = new Dictionary<string, object>();
			toReturn.Add("StateMachine", _stateMachine);
			toReturn.Add("CanTransitionTo_", _canTransitionTo_);
			toReturn.Add("CanTransitionTo", _canTransitionTo);
			toReturn.Add("StateMachineInstance", _stateMachineInstance);
			toReturn.Add("StateMachineCollectionViaStateMachineInstance", _stateMachineCollectionViaStateMachineInstance);

			return toReturn;
		}
		
		/// <summary> Adds the internals to the active context. </summary>
		protected override void AddInternalsToContext()
		{
			if(_canTransitionTo_!=null)
			{
				_canTransitionTo_.ActiveContext = base.ActiveContext;
			}
			if(_canTransitionTo!=null)
			{
				_canTransitionTo.ActiveContext = base.ActiveContext;
			}
			if(_stateMachineInstance!=null)
			{
				_stateMachineInstance.ActiveContext = base.ActiveContext;
			}
			if(_stateMachineCollectionViaStateMachineInstance!=null)
			{
				_stateMachineCollectionViaStateMachineInstance.ActiveContext = base.ActiveContext;
			}
			if(_stateMachine!=null)
			{
				_stateMachine.ActiveContext = base.ActiveContext;
			}

		}

		/// <summary> Initializes the class members</summary>
		protected virtual void InitClassMembers()
		{

			_canTransitionTo_ = null;
			_canTransitionTo = null;
			_stateMachineInstance = null;
			_stateMachineCollectionViaStateMachineInstance = null;
			_stateMachine = null;

			PerformDependencyInjection();
			
			// __LLBLGENPRO_USER_CODE_REGION_START InitClassMembers
			// __LLBLGENPRO_USER_CODE_REGION_END
			OnInitClassMembersComplete();
		}

		#region Custom Property Hashtable Setup
		/// <summary> Initializes the hashtables for the entity type and entity field custom properties. </summary>
		private static void SetupCustomPropertyHashtables()
		{
			_customProperties = new Dictionary<string, string>();
			_fieldsCustomProperties = new Dictionary<string, Dictionary<string, string>>();

			Dictionary<string, string> fieldHashtable = null;
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Id", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("StateMachineId", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Name", fieldHashtable);
		}
		#endregion

		/// <summary> Removes the sync logic for member _stateMachine</summary>
		/// <param name="signalRelatedEntity">If set to true, it will call the related entity's UnsetRelatedEntity method</param>
		/// <param name="resetFKFields">if set to true it will also reset the FK fields pointing to the related entity</param>
		private void DesetupSyncStateMachine(bool signalRelatedEntity, bool resetFKFields)
		{
			base.PerformDesetupSyncRelatedEntity( _stateMachine, new PropertyChangedEventHandler( OnStateMachinePropertyChanged ), "StateMachine", StateEntity.Relations.StateMachineEntityUsingStateMachineId, true, signalRelatedEntity, "State", resetFKFields, new int[] { (int)StateFieldIndex.StateMachineId } );		
			_stateMachine = null;
		}

		/// <summary> setups the sync logic for member _stateMachine</summary>
		/// <param name="relatedEntity">Instance to set as the related entity of type entityType</param>
		private void SetupSyncStateMachine(IEntity2 relatedEntity)
		{
			if(_stateMachine!=relatedEntity)
			{
				DesetupSyncStateMachine(true, true);
				_stateMachine = (StateMachineEntity)relatedEntity;
				base.PerformSetupSyncRelatedEntity( _stateMachine, new PropertyChangedEventHandler( OnStateMachinePropertyChanged ), "StateMachine", StateEntity.Relations.StateMachineEntityUsingStateMachineId, true, new string[] {  } );
			}
		}
		
		/// <summary>Handles property change events of properties in a related entity.</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnStateMachinePropertyChanged( object sender, PropertyChangedEventArgs e )
		{
			switch( e.PropertyName )
			{
				default:
					break;
			}
		}


		/// <summary> Initializes the class with empty data, as if it is a new Entity.</summary>
		/// <param name="validator">The validator object for this StateEntity</param>
		/// <param name="fields">Fields of this entity</param>
		protected virtual void InitClassEmpty(IValidator validator, IEntityFields2 fields)
		{
			OnInitializing();
			base.Fields = fields;
			base.IsNew=true;
			base.Validator = validator;
			InitClassMembers();

			
			// __LLBLGENPRO_USER_CODE_REGION_START InitClassEmpty
			// __LLBLGENPRO_USER_CODE_REGION_END

			OnInitialized();
		}

		#region Class Property Declarations
		/// <summary> The relations object holding all relations of this entity with other entity classes.</summary>
		public  static StateRelations Relations
		{
			get	{ return new StateRelations(); }
		}
		
		/// <summary> The custom properties for this entity type.</summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		public  static Dictionary<string, string> CustomProperties
		{
			get { return _customProperties;}
		}

		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'CanTransitionTo' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathCanTransitionTo_
		{
			get
			{
				return new PrefetchPathElement2( new EntityCollection<CanTransitionToEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CanTransitionToEntityFactory))),
					(IEntityRelation)GetRelationsForField("CanTransitionTo_")[0], (int)WorkflowService.Model.EntityType.StateEntity, (int)WorkflowService.Model.EntityType.CanTransitionToEntity, 0, null, null, null, null, "CanTransitionTo_", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany);
			}
		}
		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'CanTransitionTo' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathCanTransitionTo
		{
			get
			{
				return new PrefetchPathElement2( new EntityCollection<CanTransitionToEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CanTransitionToEntityFactory))),
					(IEntityRelation)GetRelationsForField("CanTransitionTo")[0], (int)WorkflowService.Model.EntityType.StateEntity, (int)WorkflowService.Model.EntityType.CanTransitionToEntity, 0, null, null, null, null, "CanTransitionTo", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany);
			}
		}
		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'StateMachineInstance' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathStateMachineInstance
		{
			get
			{
				return new PrefetchPathElement2( new EntityCollection<StateMachineInstanceEntity>(EntityFactoryCache2.GetEntityFactory(typeof(StateMachineInstanceEntityFactory))),
					(IEntityRelation)GetRelationsForField("StateMachineInstance")[0], (int)WorkflowService.Model.EntityType.StateEntity, (int)WorkflowService.Model.EntityType.StateMachineInstanceEntity, 0, null, null, null, null, "StateMachineInstance", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany);
			}
		}

		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'StateMachine' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathStateMachineCollectionViaStateMachineInstance
		{
			get
			{
				IEntityRelation intermediateRelation = StateEntity.Relations.StateMachineInstanceEntityUsingCurrentState;
				intermediateRelation.SetAliases(string.Empty, "StateMachineInstance_");
				return new PrefetchPathElement2(new EntityCollection<StateMachineEntity>(EntityFactoryCache2.GetEntityFactory(typeof(StateMachineEntityFactory))), intermediateRelation,
					(int)WorkflowService.Model.EntityType.StateEntity, (int)WorkflowService.Model.EntityType.StateMachineEntity, 0, null, null, GetRelationsForField("StateMachineCollectionViaStateMachineInstance"), null, "StateMachineCollectionViaStateMachineInstance", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToMany);
			}
		}

		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'StateMachine' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathStateMachine
		{
			get
			{
				return new PrefetchPathElement2(new EntityCollection(EntityFactoryCache2.GetEntityFactory(typeof(StateMachineEntityFactory))),
					(IEntityRelation)GetRelationsForField("StateMachine")[0], (int)WorkflowService.Model.EntityType.StateEntity, (int)WorkflowService.Model.EntityType.StateMachineEntity, 0, null, null, null, null, "StateMachine", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToOne);
			}
		}


		/// <summary> The custom properties for the type of this entity instance.</summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		[Browsable(false), XmlIgnore]
		public override Dictionary<string, string> CustomPropertiesOfType
		{
			get { return StateEntity.CustomProperties;}
		}

		/// <summary> The custom properties for the fields of this entity type. The returned Hashtable contains per fieldname a hashtable of name-value
		/// pairs. </summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		public  static Dictionary<string, Dictionary<string, string>> FieldsCustomProperties
		{
			get { return _fieldsCustomProperties;}
		}

		/// <summary> The custom properties for the fields of the type of this entity instance. The returned Hashtable contains per fieldname a hashtable of name-value pairs. </summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		[Browsable(false), XmlIgnore]
		public override Dictionary<string, Dictionary<string, string>> FieldsCustomPropertiesOfType
		{
			get { return StateEntity.FieldsCustomProperties;}
		}

		/// <summary> The Id property of the Entity State<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "State"."Id"<br/>
		/// Table field type characteristics (type, precision, scale, length): Int, 10, 0, 0<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): false, true, true</remarks>
		public virtual System.Int32 Id
		{
			get { return (System.Int32)GetValue((int)StateFieldIndex.Id, true); }
			set	{ SetValue((int)StateFieldIndex.Id, value); }
		}

		/// <summary> The StateMachineId property of the Entity State<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "State"."StateMachineId"<br/>
		/// Table field type characteristics (type, precision, scale, length): Int, 10, 0, 0<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): false, false, false</remarks>
		public virtual System.Int32 StateMachineId
		{
			get { return (System.Int32)GetValue((int)StateFieldIndex.StateMachineId, true); }
			set	{ SetValue((int)StateFieldIndex.StateMachineId, value); }
		}

		/// <summary> The Name property of the Entity State<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "State"."Name"<br/>
		/// Table field type characteristics (type, precision, scale, length): VarChar, 0, 0, 25<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): false, false, false</remarks>
		public virtual System.String Name
		{
			get { return (System.String)GetValue((int)StateFieldIndex.Name, true); }
			set	{ SetValue((int)StateFieldIndex.Name, value); }
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'CanTransitionToEntity' which are related to this entity via a relation of type '1:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(CanTransitionToEntity))]
		public virtual EntityCollection<CanTransitionToEntity> CanTransitionTo_
		{
			get
			{
				if(_canTransitionTo_==null)
				{
					_canTransitionTo_ = new EntityCollection<CanTransitionToEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CanTransitionToEntityFactory)));
					_canTransitionTo_.SetContainingEntityInfo(this, "ToState");
				}
				return _canTransitionTo_;
			}
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'CanTransitionToEntity' which are related to this entity via a relation of type '1:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(CanTransitionToEntity))]
		public virtual EntityCollection<CanTransitionToEntity> CanTransitionTo
		{
			get
			{
				if(_canTransitionTo==null)
				{
					_canTransitionTo = new EntityCollection<CanTransitionToEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CanTransitionToEntityFactory)));
					_canTransitionTo.SetContainingEntityInfo(this, "FromState");
				}
				return _canTransitionTo;
			}
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'StateMachineInstanceEntity' which are related to this entity via a relation of type '1:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(StateMachineInstanceEntity))]
		public virtual EntityCollection<StateMachineInstanceEntity> StateMachineInstance
		{
			get
			{
				if(_stateMachineInstance==null)
				{
					_stateMachineInstance = new EntityCollection<StateMachineInstanceEntity>(EntityFactoryCache2.GetEntityFactory(typeof(StateMachineInstanceEntityFactory)));
					_stateMachineInstance.SetContainingEntityInfo(this, "State");
				}
				return _stateMachineInstance;
			}
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'StateMachineEntity' which are related to this entity via a relation of type 'm:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(StateMachineEntity))]
		public virtual EntityCollection<StateMachineEntity> StateMachineCollectionViaStateMachineInstance
		{
			get
			{
				if(_stateMachineCollectionViaStateMachineInstance==null)
				{
					_stateMachineCollectionViaStateMachineInstance = new EntityCollection<StateMachineEntity>(EntityFactoryCache2.GetEntityFactory(typeof(StateMachineEntityFactory)));
					_stateMachineCollectionViaStateMachineInstance.IsReadOnly=true;
				}
				return _stateMachineCollectionViaStateMachineInstance;
			}
		}

		/// <summary> Gets / sets related entity of type 'StateMachineEntity' which has to be set using a fetch action earlier. If no related entity
		/// is set for this property, null is returned. This property is not visible in databound grids.</summary>
		[Browsable(false)]
		public virtual StateMachineEntity StateMachine
		{
			get
			{
				return _stateMachine;
			}
			set
			{
				if(base.IsDeserializing)
				{
					SetupSyncStateMachine(value);
				}
				else
				{
					if(value==null)
					{
						if(_stateMachine != null)
						{
							_stateMachine.UnsetRelatedEntity(this, "State");
						}
					}
					else
					{
						if(_stateMachine!=value)
						{
							((IEntity2)value).SetRelatedEntity(this, "State");
						}
					}
				}
			}
		}

	
		
		/// <summary> Gets the type of the hierarchy this entity is in. </summary>
		protected override InheritanceHierarchyType LLBLGenProIsInHierarchyOfType
		{
			get { return InheritanceHierarchyType.None;}
		}
		
		/// <summary> Gets or sets a value indicating whether this entity is a subtype</summary>
		protected override bool LLBLGenProIsSubType
		{
			get { return false;}
		}
		
		/// <summary>Returns the WorkflowService.Model.EntityType enum value for this entity.</summary>
		[Browsable(false), XmlIgnore]
		public override int LLBLGenProEntityTypeValue 
		{ 
			get { return (int)WorkflowService.Model.EntityType.StateEntity; }
		}
		#endregion


		#region Custom Entity code
		
		// __LLBLGENPRO_USER_CODE_REGION_START CustomEntityCode
		// __LLBLGENPRO_USER_CODE_REGION_END
		#endregion

		#region Included code

		#endregion
	}
}
