﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Tuesday, 28 April 2009 3:09:33 PM
// Code is generated using templates: SD.TemplateBindings.SharedTemplates.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System;
using System.Collections;
using System.Collections.Generic;
using WorkflowService.Model;
using WorkflowService.Model.FactoryClasses;
using WorkflowService.Model.HelperClasses;
using SD.LLBLGen.Pro.ORMSupportClasses;

namespace WorkflowService.Model.RelationClasses
{
	/// <summary>Implements the static Relations variant for the entity: StateMachineInstance. </summary>
	public partial class StateMachineInstanceRelations : IRelationFactory
	{
		/// <summary>CTor</summary>
		public StateMachineInstanceRelations()
		{
		}

		/// <summary>Gets all relations of the StateMachineInstanceEntity as a list of IEntityRelation objects.</summary>
		/// <returns>a list of IEntityRelation objects</returns>
		public virtual List<IEntityRelation> GetAllRelations()
		{
			List<IEntityRelation> toReturn = new List<IEntityRelation>();


			toReturn.Add(this.StateEntityUsingCurrentState);
			toReturn.Add(this.StateMachineEntityUsingStateMachineId);
			return toReturn;
		}

		#region Class Property Declarations



		/// <summary>Returns a new IEntityRelation object, between StateMachineInstanceEntity and StateEntity over the m:1 relation they have, using the relation between the fields:
		/// StateMachineInstance.CurrentState - State.Id
		/// </summary>
		public virtual IEntityRelation StateEntityUsingCurrentState
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToOne, "State", false);
				relation.AddEntityFieldPair(StateFields.Id, StateMachineInstanceFields.CurrentState);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateEntity", false);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateMachineInstanceEntity", true);
				return relation;
			}
		}
		/// <summary>Returns a new IEntityRelation object, between StateMachineInstanceEntity and StateMachineEntity over the m:1 relation they have, using the relation between the fields:
		/// StateMachineInstance.StateMachineId - StateMachine.Id
		/// </summary>
		public virtual IEntityRelation StateMachineEntityUsingStateMachineId
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToOne, "StateMachine", false);
				relation.AddEntityFieldPair(StateMachineFields.Id, StateMachineInstanceFields.StateMachineId);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateMachineEntity", false);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateMachineInstanceEntity", true);
				return relation;
			}
		}

		/// <summary>Returns a new IEntityRelation object, between StateMachineInstanceEntity and WorkflowInstanceEntity over the 1:1 relation they have, which is used to build a target per entity hierarchy, and is using the relation between the fields:
		/// StateMachineInstance.Id - WorkflowInstance.Id
		/// </summary>
		internal IEntityRelation RelationToSubTypeWorkflowInstanceEntity
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToOne, true);

				relation.AddEntityFieldPair(StateMachineInstanceFields.Id, WorkflowInstanceFields.Id);
	
	
	
				relation.IsHierarchyRelation=true;
				return relation;
			}
		}
		/// <summary>Returns the relation object the entity, to which this relation factory belongs, has with the subtype with the specified name</summary>
		/// <param name="subTypeEntityName">name of direct subtype which is a subtype of the current entity through the relation to return.</param>
		/// <returns>relation which makes the current entity a supertype of the subtype entity with the name specified, or null if not applicable/found</returns>
		public virtual IEntityRelation GetSubTypeRelation(string subTypeEntityName)
		{
			switch(subTypeEntityName)
			{
				case "WorkflowInstanceEntity":
					return this.RelationToSubTypeWorkflowInstanceEntity;
				default:
					return null;
			}
		}
		
		
		/// <summary>Returns the relation object the entity, to which this relation factory belongs, has with its supertype, if applicable.</summary>
		/// <returns>relation which makes the current entity a subtype of its supertype entity or null if not applicable/found</returns>
		public virtual IEntityRelation GetSuperTypeRelation()
		{
			return null;
		}

		#endregion

		#region Included Code

		#endregion
	}
}
