﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Tuesday, 28 April 2009 3:09:33 PM
// Code is generated using templates: SD.TemplateBindings.SharedTemplates.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System;
using System.Collections;
using System.Collections.Generic;
using WorkflowService.Model;
using WorkflowService.Model.FactoryClasses;
using WorkflowService.Model.HelperClasses;
using SD.LLBLGen.Pro.ORMSupportClasses;

namespace WorkflowService.Model.RelationClasses
{
	/// <summary>Implements the static Relations variant for the entity: StateMachine. </summary>
	public partial class StateMachineRelations : IRelationFactory
	{
		/// <summary>CTor</summary>
		public StateMachineRelations()
		{
		}

		/// <summary>Gets all relations of the StateMachineEntity as a list of IEntityRelation objects.</summary>
		/// <returns>a list of IEntityRelation objects</returns>
		public virtual List<IEntityRelation> GetAllRelations()
		{
			List<IEntityRelation> toReturn = new List<IEntityRelation>();
			toReturn.Add(this.StateEntityUsingStateMachineId);
			toReturn.Add(this.StateMachineInstanceEntityUsingStateMachineId);


			return toReturn;
		}

		#region Class Property Declarations

		/// <summary>Returns a new IEntityRelation object, between StateMachineEntity and StateEntity over the 1:n relation they have, using the relation between the fields:
		/// StateMachine.Id - State.StateMachineId
		/// </summary>
		public virtual IEntityRelation StateEntityUsingStateMachineId
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany, "State" , true);
				relation.AddEntityFieldPair(StateMachineFields.Id, StateFields.StateMachineId);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateMachineEntity", true);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateEntity", false);
				return relation;
			}
		}

		/// <summary>Returns a new IEntityRelation object, between StateMachineEntity and StateMachineInstanceEntity over the 1:n relation they have, using the relation between the fields:
		/// StateMachine.Id - StateMachineInstance.StateMachineId
		/// </summary>
		public virtual IEntityRelation StateMachineInstanceEntityUsingStateMachineId
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany, "StateMachineInstance" , true);
				relation.AddEntityFieldPair(StateMachineFields.Id, StateMachineInstanceFields.StateMachineId);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateMachineEntity", true);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateMachineInstanceEntity", false);
				return relation;
			}
		}



		/// <summary>Returns a new IEntityRelation object, between StateMachineEntity and WorkflowEntity over the 1:1 relation they have, which is used to build a target per entity hierarchy, and is using the relation between the fields:
		/// StateMachine.Id - Workflow.Id
		/// </summary>
		internal IEntityRelation RelationToSubTypeWorkflowEntity
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToOne, true);

				relation.AddEntityFieldPair(StateMachineFields.Id, WorkflowFields.Id);
	
	
	
				relation.IsHierarchyRelation=true;
				return relation;
			}
		}
		/// <summary>Returns the relation object the entity, to which this relation factory belongs, has with the subtype with the specified name</summary>
		/// <param name="subTypeEntityName">name of direct subtype which is a subtype of the current entity through the relation to return.</param>
		/// <returns>relation which makes the current entity a supertype of the subtype entity with the name specified, or null if not applicable/found</returns>
		public virtual IEntityRelation GetSubTypeRelation(string subTypeEntityName)
		{
			switch(subTypeEntityName)
			{
				case "WorkflowEntity":
					return this.RelationToSubTypeWorkflowEntity;
				default:
					return null;
			}
		}
		
		
		/// <summary>Returns the relation object the entity, to which this relation factory belongs, has with its supertype, if applicable.</summary>
		/// <returns>relation which makes the current entity a subtype of its supertype entity or null if not applicable/found</returns>
		public virtual IEntityRelation GetSuperTypeRelation()
		{
			return null;
		}

		#endregion

		#region Included Code

		#endregion
	}
}
