﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Tuesday, 28 April 2009 3:09:33 PM
// Code is generated using templates: SD.TemplateBindings.SharedTemplates.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System;
using System.Collections;
using System.Collections.Generic;
using WorkflowService.Model;
using WorkflowService.Model.FactoryClasses;
using WorkflowService.Model.HelperClasses;
using SD.LLBLGen.Pro.ORMSupportClasses;

namespace WorkflowService.Model.RelationClasses
{
	/// <summary>Implements the static Relations variant for the entity: Workflow. </summary>
	public partial class WorkflowRelations : StateMachineRelations
	{
		/// <summary>CTor</summary>
		public WorkflowRelations()
		{
		}

		/// <summary>Gets all relations of the WorkflowEntity as a list of IEntityRelation objects.</summary>
		/// <returns>a list of IEntityRelation objects</returns>
		public override List<IEntityRelation> GetAllRelations()
		{
			List<IEntityRelation> toReturn = base.GetAllRelations();



			return toReturn;
		}

		#region Class Property Declarations

		/// <summary>Returns a new IEntityRelation object, between WorkflowEntity and StateEntity over the 1:n relation they have, using the relation between the fields:
		/// Workflow.Id - State.StateMachineId
		/// </summary>
		public override IEntityRelation StateEntityUsingStateMachineId
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany, "State" , true);
				relation.AddEntityFieldPair(WorkflowFields.Id, StateFields.StateMachineId);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("WorkflowEntity", true);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateEntity", false);
				return relation;
			}
		}

		/// <summary>Returns a new IEntityRelation object, between WorkflowEntity and StateMachineInstanceEntity over the 1:n relation they have, using the relation between the fields:
		/// Workflow.Id - StateMachineInstance.StateMachineId
		/// </summary>
		public override IEntityRelation StateMachineInstanceEntityUsingStateMachineId
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany, "StateMachineInstance" , true);
				relation.AddEntityFieldPair(WorkflowFields.Id, StateMachineInstanceFields.StateMachineId);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("WorkflowEntity", true);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateMachineInstanceEntity", false);
				return relation;
			}
		}



		/// <summary>Returns a new IEntityRelation object, between WorkflowEntity and StateMachineEntity over the 1:1 relation they have, which is used to build a target per entity hierarchy, and is using the relation between the fields:
		/// Workflow.Id - StateMachine.Id
		/// </summary>
		internal IEntityRelation RelationToSuperTypeStateMachineEntity
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToOne, false);

	
	
				relation.AddEntityFieldPair(StateMachineFields.Id, WorkflowFields.Id);
	
				relation.IsHierarchyRelation=true;
				return relation;
			}
		}
		/// <summary>Returns the relation object the entity, to which this relation factory belongs, has with the subtype with the specified name</summary>
		/// <param name="subTypeEntityName">name of direct subtype which is a subtype of the current entity through the relation to return.</param>
		/// <returns>relation which makes the current entity a supertype of the subtype entity with the name specified, or null if not applicable/found</returns>
		public override IEntityRelation GetSubTypeRelation(string subTypeEntityName)
		{
			return null;
		}
		
		
		/// <summary>Returns the relation object the entity, to which this relation factory belongs, has with its supertype, if applicable.</summary>
		/// <returns>relation which makes the current entity a subtype of its supertype entity or null if not applicable/found</returns>
		public override IEntityRelation GetSuperTypeRelation()
		{
			return this.RelationToSuperTypeStateMachineEntity;
		}

		#endregion

		#region Included Code

		#endregion
	}
}
