﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Tuesday, 28 April 2009 3:09:34 PM
// Code is generated using templates: SD.TemplateBindings.SqlServerSpecific.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System;
using System.Collections;
using System.Data;

using SD.LLBLGen.Pro.ORMSupportClasses;

namespace WorkflowService.Model.DatabaseSpecific
{
	/// <summary>
	/// Singleton implementation of the PersistenceInfoProvider. This class is the singleton wrapper through which the actual instance is retrieved.
	/// </summary>
	/// <remarks>It uses a single instance of an internal class. The access isn't marked with locks as the PersistenceInfoProviderBase class is threadsafe.</remarks>
	internal sealed class PersistenceInfoProviderSingleton
	{
		#region Class Member Declarations
		private static readonly IPersistenceInfoProvider _providerInstance = new PersistenceInfoProviderCore();
		#endregion
		
		/// <summary>private ctor to prevent instances of this class.</summary>
		private PersistenceInfoProviderSingleton()
		{
		}

		/// <summary>Dummy static constructor to make sure threadsafe initialization is performed.</summary>
		static PersistenceInfoProviderSingleton()
		{
		}

		/// <summary>Gets the singleton instance of the PersistenceInfoProviderCore</summary>
		/// <returns>Instance of the PersistenceInfoProvider.</returns>
		public static IPersistenceInfoProvider GetInstance()
		{
			return _providerInstance;
		}
	}

	/// <summary>Actual implementation of the PersistenceInfoProvider. Used by singleton wrapper.</summary>
	internal class PersistenceInfoProviderCore : PersistenceInfoProviderBase
	{
		/// <summary>Initializes a new instance of the <see cref="PersistenceInfoProviderCore"/> class.</summary>
		internal PersistenceInfoProviderCore()
		{
			Init();
		}

		/// <summary>Method which initializes the internal datastores with the structure of hierarchical types.</summary>
		private void Init()
		{
			base.InitClass((8 + 0));
			InitCanTransitionToEntityMappings();
			InitMustHaveRoleEntityMappings();
			InitRoleEntityMappings();
			InitStateEntityMappings();
			InitStateMachineEntityMappings();
			InitStateMachineInstanceEntityMappings();
			InitWorkflowEntityMappings();
			InitWorkflowInstanceEntityMappings();

		}


		/// <summary>Inits CanTransitionToEntity's mappings</summary>
		private void InitCanTransitionToEntityMappings()
		{
			base.AddElementMapping( "CanTransitionToEntity", "Workflow", @"dbo", "CanTransitionTo", 3 );
			base.AddElementFieldMapping( "CanTransitionToEntity", "Id", "Id", false, (int)SqlDbType.Int, 0, 0, 10, true, "SCOPE_IDENTITY()", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "CanTransitionToEntity", "FromStateId", "FromStateId", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 1 );
			base.AddElementFieldMapping( "CanTransitionToEntity", "ToStateId", "ToStateId", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 2 );
		}
		/// <summary>Inits MustHaveRoleEntity's mappings</summary>
		private void InitMustHaveRoleEntityMappings()
		{
			base.AddElementMapping( "MustHaveRoleEntity", "Workflow", @"dbo", "MustHaveRole", 2 );
			base.AddElementFieldMapping( "MustHaveRoleEntity", "CanTransitionToId", "CanTransitionToId", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "MustHaveRoleEntity", "RoleId", "RoleId", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 1 );
		}
		/// <summary>Inits RoleEntity's mappings</summary>
		private void InitRoleEntityMappings()
		{
			base.AddElementMapping( "RoleEntity", "Workflow", @"dbo", "Role", 2 );
			base.AddElementFieldMapping( "RoleEntity", "Id", "Id", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "RoleEntity", "Name", "Name", false, (int)SqlDbType.VarChar, 25, 0, 0, false, "", null, typeof(System.String), 1 );
		}
		/// <summary>Inits StateEntity's mappings</summary>
		private void InitStateEntityMappings()
		{
			base.AddElementMapping( "StateEntity", "Workflow", @"dbo", "State", 3 );
			base.AddElementFieldMapping( "StateEntity", "Id", "Id", false, (int)SqlDbType.Int, 0, 0, 10, true, "SCOPE_IDENTITY()", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "StateEntity", "StateMachineId", "StateMachineId", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 1 );
			base.AddElementFieldMapping( "StateEntity", "Name", "Name", false, (int)SqlDbType.VarChar, 25, 0, 0, false, "", null, typeof(System.String), 2 );
		}
		/// <summary>Inits StateMachineEntity's mappings</summary>
		private void InitStateMachineEntityMappings()
		{
			base.AddElementMapping( "StateMachineEntity", "Workflow", @"dbo", "StateMachine", 2 );
			base.AddElementFieldMapping( "StateMachineEntity", "Id", "Id", false, (int)SqlDbType.Int, 0, 0, 10, true, "SCOPE_IDENTITY()", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "StateMachineEntity", "Name", "Name", false, (int)SqlDbType.VarChar, 25, 0, 0, false, "", null, typeof(System.String), 1 );
		}
		/// <summary>Inits StateMachineInstanceEntity's mappings</summary>
		private void InitStateMachineInstanceEntityMappings()
		{
			base.AddElementMapping( "StateMachineInstanceEntity", "Workflow", @"dbo", "StateMachineInstance", 3 );
			base.AddElementFieldMapping( "StateMachineInstanceEntity", "Id", "Id", false, (int)SqlDbType.Int, 0, 0, 10, true, "SCOPE_IDENTITY()", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "StateMachineInstanceEntity", "StateMachineId", "StateMachineId", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 1 );
			base.AddElementFieldMapping( "StateMachineInstanceEntity", "CurrentState", "CurrentState", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 2 );
		}
		/// <summary>Inits WorkflowEntity's mappings</summary>
		private void InitWorkflowEntityMappings()
		{
			base.AddElementMapping( "WorkflowEntity", "Workflow", @"dbo", "Workflow", 2 );
			base.AddElementFieldMapping( "WorkflowEntity", "Id", "Id", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "WorkflowEntity", "Guid", "Guid", false, (int)SqlDbType.UniqueIdentifier, 0, 0, 0, false, "", null, typeof(System.Guid), 1 );
		}
		/// <summary>Inits WorkflowInstanceEntity's mappings</summary>
		private void InitWorkflowInstanceEntityMappings()
		{
			base.AddElementMapping( "WorkflowInstanceEntity", "Workflow", @"dbo", "WorkflowInstance", 2 );
			base.AddElementFieldMapping( "WorkflowInstanceEntity", "Id", "Id", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "WorkflowInstanceEntity", "Guid", "Guid", false, (int)SqlDbType.UniqueIdentifier, 0, 0, 0, false, "", null, typeof(System.Guid), 1 );
		}

	}
}













